/*
   file MCalc.java jlouie 3.97
   tested with JDK 1.1 release Win95.
   v112 extends WFrame which contains empty implementations of WindowListener
 */

import java.awt.*;
import java.awt.event.*;

public class MCalc extends WFrame 
                     implements  ActionListener,
                                 ItemListener,
                                 KeyListener { 
                     

   public MCalc() {
      //{{INIT_CONTROLS
      setLayout(null);
      addNotify();
      resize(insets().left + insets().right + 400,insets().top + insets().bottom + 300);
      setFont(new Font("Dialog", Font.PLAIN, 12));
      setBackground(new Color(12632256));
      textFieldPrinciple = new java.awt.TextField();
      textFieldPrinciple.reshape(insets().left + 204,insets().top + 60,168,24);
      add(textFieldPrinciple);
      textFieldInterest = new java.awt.TextField();
      textFieldInterest.reshape(insets().left + 204,insets().top + 96,168,24);
      add(textFieldInterest);
      Group1 = new CheckboxGroup();
      radioButtonInterest = new java.awt.Checkbox("Interest...................%", Group1, false);
      radioButtonInterest.reshape(insets().left + 24,insets().top + 96,160,24);
      add(radioButtonInterest);
      radioButtonPayments = new java.awt.Checkbox("Payments................$", Group1, true);
      radioButtonPayments.reshape(insets().left + 24,insets().top + 168,160,24);
      add(radioButtonPayments);
      buttonCalculate = new java.awt.Button("Calculate <Enter>");
      buttonCalculate.reshape(insets().left + 60,insets().top + 216,128,28);
      buttonCalculate.setFont(new Font("Dialog", Font.BOLD, 12));
      add(buttonCalculate);
      textFieldMonths = new java.awt.TextField();
      textFieldMonths.reshape(insets().left + 204,insets().top + 132,168,24);
      add(textFieldMonths);
      textFieldPayments = new java.awt.TextField();
      textFieldPayments.setEditable(false);
      textFieldPayments.setText("0");
      textFieldPayments.reshape(insets().left + 204,insets().top + 168,168,24);
      add(textFieldPayments);
      radioButtonPrinciple = new java.awt.Checkbox("Principle..................$", Group1, false);
      radioButtonPrinciple.reshape(insets().left + 24,insets().top + 60,160,24);
      add(radioButtonPrinciple);
      radioButtonMonths = new java.awt.Checkbox("Months...................M", Group1, false);
      radioButtonMonths.reshape(insets().left + 24,insets().top + 132,160,24);
      add(radioButtonMonths);
      labelMessage = new java.awt.Label("A Mortgage Calculator");
      labelMessage.reshape(insets().left + 24,insets().top + 24,152,24);
      add(labelMessage);
      textFieldMessage = new java.awt.TextField();
      textFieldMessage.setEditable(false);
      textFieldMessage.setText("Calculate Payments");
      textFieldMessage.reshape(insets().left + 204,insets().top + 24,168,24);
      add(textFieldMessage);
      buttonQuit = new java.awt.Button("Quit");
      buttonQuit.reshape(insets().left + 204,insets().top + 216,96,28);
      add(buttonQuit);
      setTitle("MCalc");
      //}}

      //{{INIT_MENUS
      mainMenuBar = new java.awt.MenuBar();
      menu1 = new java.awt.Menu("File");
      itemCalculate= new MenuItem("Calculate");
      menu1.add(itemCalculate);
      menu1.addSeparator();
      itemExit= new MenuItem("Exit");
      menu1.add(itemExit);
      mainMenuBar.add(menu1);
      menu2 = new java.awt.Menu("Edit");
      mainMenuBar.add(menu2);                                        
      menu3 = new java.awt.Menu("Help");
      mainMenuBar.setHelpMenu(menu3);
      itemAbout= new MenuItem("About...");
      menu3.add(itemAbout);
      mainMenuBar.add(menu3);
      setMenuBar(mainMenuBar);
      //$$ mainMenuBar.move(0,0);
      //}}
      UserInits();
   }

   private void UserInits() {
       InitTextArray();
       model= new Model();
       textFieldTarget= textFieldPayments;
       textFieldPrinciple.requestFocus();
       buttonQuit.addActionListener(this);
       buttonCalculate.addActionListener(this);
       itemCalculate.addActionListener(this);
       itemExit.addActionListener(this);
       itemAbout.addActionListener(this);  
       radioButtonInterest.addItemListener(this);
       radioButtonPayments.addItemListener(this);
       radioButtonMonths.addItemListener(this);
       radioButtonPrinciple.addItemListener(this);
       addWindowListener(this);
       for (int i=0; i<arrayTextFields.length; i++) {
         arrayTextFields[i].addActionListener(this);
         arrayTextFields[i].addKeyListener(this);
       }
   }

   public MCalc(String title) {
       this();
       setTitle(title);
   }

    public MCalc(boolean isApplication) {
        this();
        this.isApplication= isApplication;
    }

    public synchronized void show() {
      move(50, 50);
      super.show();
    }

   static public void main(String args[]) {
       (new MCalc()).show();
   }

   //{{DECLARE_CONTROLS
   java.awt.FileDialog openFileDialog1;
   java.awt.TextField textFieldPrinciple;
   java.awt.TextField textFieldInterest;
   java.awt.Checkbox radioButtonInterest;
   CheckboxGroup Group1;
   java.awt.Checkbox radioButtonPayments;
   java.awt.Button buttonCalculate;
   java.awt.TextField textFieldMonths;
   java.awt.TextField textFieldPayments;
   java.awt.Checkbox radioButtonPrinciple;
   java.awt.Checkbox radioButtonMonths;
   java.awt.Label labelMessage;
   java.awt.TextField textFieldMessage;
   java.awt.Button buttonQuit;
   //}}

   //{{DECLARE_MENUS
   java.awt.MenuBar mainMenuBar;
   java.awt.Menu menu1;
   java.awt.Menu menu2;
   java.awt.Menu menu3;
   //}}

   //====================
   // User Data
   //====================

   private  java.awt.MenuItem itemExit;
   private  java.awt.MenuItem itemCalculate;
   private  java.awt.MenuItem itemAbout;
   private  TextField[] arrayTextFields= new TextField[4];
   private  TextField   textFieldTarget;
   private  Model       model;
   private  boolean     isApplication= true;

   //====================
   // User Methods
   //====================

   private void InitTextArray() {
       arrayTextFields[0]= textFieldPrinciple;
       arrayTextFields[1]= textFieldInterest;
       arrayTextFields[2]= textFieldMonths;
       arrayTextFields[3]= textFieldPayments;
   }

   private void DoCalc() {
       TextField target;
       String message= "";
                       
       target= textFieldTarget;
       if (target != null) target.setText("0");
       message= model.DoCalc(arrayTextFields);
       textFieldMessage.setText(message);
       target= GetNextTextField(target);
       if (target != null) {
           target.requestFocus();
           target.selectAll();
       }
   }

    private TextField GetNextTextField(TextField tf){
        TextField temp= null;

        if (tf == arrayTextFields[0]) temp= arrayTextFields[1];
        if (tf == arrayTextFields[1]) temp= arrayTextFields[2];
        if (tf == arrayTextFields[2]) temp= arrayTextFields[3];
        if (tf == arrayTextFields[3]) temp= arrayTextFields[0];
        if (temp == null) return tf; // error!
        if (temp.isEditable()) return temp;
        else return (GetNextTextField(temp));
    }

    private TextField GetPreviousTextField(TextField tf){
        TextField temp= null;

        if (tf == arrayTextFields[0]) temp= arrayTextFields[3];
        if (tf == arrayTextFields[1]) temp= arrayTextFields[0];
        if (tf == arrayTextFields[2]) temp= arrayTextFields[1];
        if (tf == arrayTextFields[3]) temp= arrayTextFields[2];
        if (temp == null) return tf; // error! should not get here.
        if (temp.isEditable()) return temp;
        else return (GetPreviousTextField(temp));
    }

   
   private void DoExit() {
      setVisible(false);
      dispose();
      if (isApplication) {
         System.exit(0);
      }
   }


   // override windowClosing in WFrame
   
   public void windowClosing(WindowEvent event) {
      DoExit();
   }  
   
   public void actionPerformed(ActionEvent event) {
      Object source= event.getSource();
      if (source instanceof Button) {
         if (source == buttonQuit) {
            (new QuitDialog(this, "Quit MCalc?", true)).show();
         }
         else if (source == buttonCalculate) {
            DoCalc();
         }
         else if (((Button)source).getLabel().equalsIgnoreCase(" Y e s ")) {
            DoExit();  
         }
      }
      if (source instanceof MenuItem) {
         if (source == itemCalculate) {
            DoCalc();
         }
         else if (source == itemExit) {
            (new QuitDialog(this, "Quit MCalc?", true)).show();
         }
         else if (source == itemAbout) {
            (new AboutDialog(this, true)).show();
         }
      }
      if (source instanceof TextField) {
         DoCalc();
      }
   }
   
   public void itemStateChanged(ItemEvent event) {
      Object source= event.getSource();
      TextField current= null;
      TextField next= null;
      
      if (source instanceof Checkbox) {
         if (source == radioButtonPrinciple) {
            textFieldMessage.setText("Calculate Principle");
            current= textFieldPrinciple;
            next= textFieldInterest;
         }
         else if (source == radioButtonInterest) {
            textFieldMessage.setText("Calculate Interest");
            current= textFieldInterest;
            next= textFieldMonths;
         }
         else if (source == radioButtonMonths) {
            textFieldMessage.setText("Calculate Months");
            current= textFieldMonths;
            next= textFieldPayments;
         }
         else if (source == radioButtonPayments) {
            textFieldMessage.setText("Calculate Payment");
            current= textFieldPayments;
            next= textFieldPrinciple;
         }                 
         if (current != null) {
            textFieldTarget.setEditable(true); 
            //String text= textFieldTarget.getText(); //workaround
            //textFieldTarget.setText(text);            
            current.setEditable(false);     // buggy  Win95
            current.setText("0");           // workaround
            textFieldTarget= current;
            if (next != null) {
               next.selectAll();
               next.requestFocus(); 
            } 
         }  
      }
   }  
   
   public void keyTyped(KeyEvent event) {
   }
   
   public void keyReleased(KeyEvent event) {
   }
   
   public void keyPressed(KeyEvent event) {
      Object source= event.getSource();
      TextField temp= arrayTextFields[0];
      if (source instanceof TextField) {
           char key= event.getKeyChar();
           if (key == '\t') {
               if (event.isShiftDown()) {
                  temp= GetPreviousTextField((TextField)source);
               }
               else {
                  temp= GetNextTextField((TextField)source);
               }
               if (temp != null) {
                  ((TextField)source).select(0,0); //workaround
                  temp.requestFocus();
                  temp.selectAll();
                  event.consume();           
               }
            }
      }   
   }
}
