/*
    A basic extension of the java.awt.Dialog class
    file QuitDialog.java jlouie 6.97
    tested with JDK 1.1 Win95
    v113 demonstrates the use of inner classes and adapters
 */

import java.awt.*;
import java.awt.event.*;

public class QuitDialog extends Dialog {

   public QuitDialog(Frame parent, boolean modal) {
      super(parent, modal);

      //{{INIT_CONTROLS
      setLayout(new FlowLayout(FlowLayout.CENTER,20,10));
      addNotify();
      setSize(getInsets().left + getInsets().right + 317,getInsets().top + getInsets().bottom + 97);
      yesButton = new java.awt.Button(" Y e s ");
      yesButton.setLocation(getInsets().left + 91,getInsets().top + 5);
      yesButton.setSize(66,32);
      yesButton.setFont(new Font("Dialog", Font.BOLD, 20));
      add(yesButton);
      noButton = new java.awt.Button("  N o  ");
      noButton.setLocation(getInsets().left + 162,getInsets().top + 5);
      noButton.setSize(64,32);
      noButton.setFont(new Font("Dialog", Font.BOLD, 20));
      add(noButton);
      setTitle("Really Quit?");
      setResizable(false);
      this.parent= parent;
      registerListeners();     
   }
   
   private void registerListeners() {
      addWindowListener(new WindowClosingListener());
      noButton.addActionListener(new QuitDialog.AbortActionListener());
      yesButton.addActionListener(new QuitDialog.QuitActionListener());
   }

   public QuitDialog(Frame parent, String title, boolean modal) {
       this(parent, modal);
       setTitle(title);
   }

   public synchronized void show() {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();

      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
           bounds.y + (bounds.height - abounds.height)/2);

      super.show();
   }

   //{{DECLARE_CONTROLS
   java.awt.Button yesButton;
   java.awt.Button noButton;
   //}}
   
   java.awt.Frame parent;  
      
   
   // inner classes and adapters
   
   class WindowClosingListener extends WindowAdapter {
      public void windowClosing(WindowEvent event) {
         setVisible(false);
         dispose();
         parent.toFront();
      }
   }

   
   class QuitActionListener implements ActionListener {
      public void actionPerformed(ActionEvent e) {
         if (parent instanceof YesNoInterface) {
            setVisible(false);
            ((YesNoInterface)parent).doYes(this,"Quit");
         }
      }
   }
   
   class AbortActionListener implements ActionListener {
      public void actionPerformed(ActionEvent e) {
          setVisible(false);
          dispose();
          if (parent instanceof YesNoInterface) {
            ((YesNoInterface)parent).doNo(this,"Don't Quit");
          }
      }
   }
   
}
