/*
    A basic extension of the java.awt.Dialog class
    file AboutDialog.java jlouie 7.97
    Tested with JDK 1.1 Win95
    v115 demonstrates the use of adapters and local/anonymous inner classes
 */

import java.awt.*;
import java.awt.event.*;

public class AboutDialog extends Dialog implements  ActionListener {


   public AboutDialog(Frame parent, boolean modal) {

       super(parent, modal);

      //{{INIT_CONTROLS
      setLayout(null);
      addNotify();
      setSize(getInsets().left + getInsets().right + 302,getInsets().top + getInsets().bottom + 84);
      label1 = new java.awt.Label("A Basic Java  Application");
      label1.setLocation(getInsets().left + 2,getInsets().top + 27);
      label1.setSize(170,31);
      add(label1);
      okButton = new java.awt.Button("OK");
      okButton.setLocation(getInsets().left + 177,getInsets().top + 15);
      okButton.setSize(95,26);
      add(okButton);
      setTitle("About");
      setResizable(false);
      //}}
      okButton.addActionListener(this);
      
      // use of anonymous inner class and the covenience class WindowAdapter
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent event) {
            doClose();
         }    
      });
      
      f= parent;
   }

   public AboutDialog(Frame parent, String title, boolean modal) {
       this(parent, modal);
       setTitle(title);
   }

   public synchronized void show() {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();   

      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
           bounds.y + (bounds.height - abounds.height)/2);

      super.show();
   }

   //{{DECLARE_CONTROLS
   java.awt.Label label1;
   java.awt.Button okButton;
   //}}
   
   java.awt.Frame f;
   
   // implement method in ActionListener
   
   public void actionPerformed(ActionEvent event) {
      doClose();
   }
   
   // private access by inner classes is not implemented in JDK1.1
   
   void doClose() {
      setVisible(false);
      f.toFront();
      dispose();
   }
   
}
