/*
   file MCalc.java jlouie 7.97
   tested with JDK 1.1 release Win95.
   this version 1.1.6 demonstrates the use of
   an adapter to translate the event interface
   into a paramter based application interface using 
   local/anonymous inner classes
 */

import java.awt.*;
import java.awt.event.*;

public class MCalc extends Frame implements  YesNoInterface { 

   //doCommand constants
                     
   //static final int ERROR_COMMAND=        -1;
   //static final int NO_COMMAND=           0;
   static final int CALCULATE_COMMAND=      1;
   static final int SHOW_QUIT_COMMAND=      2;
   static final int SHOW_ABOUT_COMMAND=     3;
   static final int QUIT_COMMAND=           4;
    
   public MCalc() {
      //{{INIT_CONTROLS
      setLayout(null);
      addNotify();
      setSize(getInsets().left + getInsets().right + 400,getInsets().top + getInsets().bottom + 300);
      setFont(new Font("Dialog", Font.PLAIN, 12));
      setBackground(new Color(12632256));
      textFieldPrinciple = new java.awt.TextField();
      textFieldPrinciple.setLocation(getInsets().left + 204,getInsets().top + 60);
      textFieldPrinciple.setSize(168,24);
      add(textFieldPrinciple);
      textFieldInterest = new java.awt.TextField();
      textFieldInterest.setLocation(getInsets().left + 204,getInsets().top + 96);
      textFieldInterest.setSize(168,24);
      add(textFieldInterest);
      Group1 = new CheckboxGroup();
      radioButtonInterest = new java.awt.Checkbox("Interest...................%", Group1, false);
      radioButtonInterest.setLocation(getInsets().left + 24,getInsets().top + 96);
      radioButtonInterest.setSize(160,24);
      add(radioButtonInterest);
      radioButtonPayments = new java.awt.Checkbox("Payments................$", Group1, true);
      radioButtonPayments.setLocation(getInsets().left + 24,getInsets().top + 168);
      radioButtonPayments.setSize(160,24);
      add(radioButtonPayments);
      buttonCalculate = new java.awt.Button("Calculate <Enter>");
      buttonCalculate.setLocation(getInsets().left + 60,getInsets().top + 216);
      buttonCalculate.setSize(128,28);
      buttonCalculate.setFont(new Font("Dialog", Font.BOLD, 12));
      add(buttonCalculate);
      textFieldMonths = new java.awt.TextField();
      textFieldMonths.setLocation(getInsets().left + 204,getInsets().top + 132);
      textFieldMonths.setSize(168,24);
      add(textFieldMonths);
      textFieldPayments = new java.awt.TextField();
      textFieldPayments.setEditable(false);
      textFieldPayments.setText("0");
      textFieldPayments.setLocation(getInsets().left + 204,getInsets().top + 168);
      textFieldPayments.setSize(168,24);
      add(textFieldPayments);
      radioButtonPrinciple = new java.awt.Checkbox("Principle..................$", Group1, false);
      radioButtonPrinciple.setLocation(getInsets().left + 24,getInsets().top + 60);
      radioButtonPrinciple.setSize(160,24);
      add(radioButtonPrinciple);
      radioButtonMonths = new java.awt.Checkbox("Months...................M", Group1, false);
      radioButtonMonths.setLocation(getInsets().left + 24,getInsets().top + 132);
      radioButtonMonths.setSize(160,24);
      add(radioButtonMonths);
      labelMessage = new java.awt.Label("A Mortgage Calculator");
      labelMessage.setLocation(getInsets().left + 24,getInsets().top + 24);
      labelMessage.setSize(152,24);
      add(labelMessage);
      textFieldMessage = new java.awt.TextField();
      textFieldMessage.setEditable(false);
      textFieldMessage.setText("Calculate Payments");
      textFieldMessage.setLocation(getInsets().left + 204,getInsets().top + 24);
      textFieldMessage.setSize(168,24);
      add(textFieldMessage);
      buttonQuit = new java.awt.Button("Quit");
      buttonQuit.setLocation(getInsets().left + 204,getInsets().top + 216);
      buttonQuit.setSize(96,28);
      add(buttonQuit);
      setTitle("MCalc");
      //}}

      //{{INIT_MENUS
      mainMenuBar = new java.awt.MenuBar();
      menu1 = new java.awt.Menu("File");
      itemCalculate= new MenuItem("Calculate");
      menu1.add(itemCalculate);
      menu1.addSeparator();
      itemExit= new MenuItem("Exit");
      menu1.add(itemExit);
      mainMenuBar.add(menu1);
      menu2 = new java.awt.Menu("Edit");
      mainMenuBar.add(menu2);                                        
      menu3 = new java.awt.Menu("Help");
      mainMenuBar.setHelpMenu(menu3);
      itemAbout= new MenuItem("About...");
      menu3.add(itemAbout);
      mainMenuBar.add(menu3);
      setMenuBar(mainMenuBar);
      //$$ mainMenuBar.move(0,0);
      //}}
      userInits();
      registerListeners();
   }

   private void userInits() {
       initTextArray();
       model= new Model();
       textFieldTarget= textFieldPayments;
       textFieldPrinciple.requestFocus();      
   }
   
   void doCommand(int command) {
      switch(command) {
         case CALCULATE_COMMAND:
            doCalc();
            break;
         case SHOW_QUIT_COMMAND:
            (new QuitDialog(this,"Quit MCalc?",true)).show();
            break;
         case SHOW_ABOUT_COMMAND:
            (new AboutDialog(this,true)).show();
            break;
         case QUIT_COMMAND:
            doExit();
            break;
         default:
            System.out.println("Command out of range in doCommand.");
            break;
      }
   }
   
   
   // in this version, one uses local inner classes
   // to bind events to instances of an adapter
   // one also binds events to a parameter based app method
   // the command property must be declared final
   
   // bind component events to the doCommand handler
   
   private void bindActionListener(Object o, final int command) {
      class ActionListenerAdapter implements ActionListener {
         public void actionPerformed(ActionEvent event) {
            doCommand(command);
         }
      }
      ActionListenerAdapter listener= new ActionListenerAdapter();
      if (o instanceof MenuItem) {
         ((MenuItem)o).addActionListener(listener);
      }
      else if (o instanceof Button) {
         ((Button)o).addActionListener(listener);
      }
      else if (o instanceof TextField) {
         ((TextField)o).addActionListener(listener);
      }
   }
   
   // much ado about nuthin
   
   private void bindWindowListener(Window w, final int command) {
      class WindowClosingAdapter extends WindowAdapter {
         public void windowClosing(WindowEvent event) {
            doCommand(command);
         }
      }
      w.addWindowListener(new WindowClosingAdapter());
   }
   
   // ok register the listeners
   
   private void registerListeners() {
   
      // define local inner classes
            
      class TabKeyListener extends KeyAdapter {
         public void keyPressed(KeyEvent event) {
            Object source= event.getSource();
            TextField temp= arrayTextFields[0];
            if (source instanceof TextField) {
            char key= event.getKeyChar();
            if (key == '\t') {
                  if (event.isShiftDown()) {
                     temp= getPreviousTextField((TextField)source);
                  }
                  else {
                     temp= getNextTextField((TextField)source);
                  }
                  if (temp != null) {
                     ((TextField)source).select(0,0); //workaround
                     temp.requestFocus();
                     temp.selectAll();
                     event.consume();           
                  }
               }
            }   
         }
      }
      
      // instanciate TabKeyListener
      
      KeyListener tabKeyListener= new TabKeyListener();
      
      class ItemStateChangedListener implements ItemListener {
         String s= "";
         TextField current= null;
         TextField next= null;    
                      
         public ItemStateChangedListener(String s,TextField current, TextField next) {
            this.s= s;
            this.current= current;
            this.next= next;
         }
         
         public void itemStateChanged(ItemEvent event) {
            updateControls(s,current,next);
         }  
      }     
      
      // bind listeners
      
      bindActionListener(buttonQuit, SHOW_QUIT_COMMAND);
      bindActionListener(buttonCalculate, CALCULATE_COMMAND);     
      bindActionListener(itemCalculate, CALCULATE_COMMAND);
      bindActionListener(itemExit, SHOW_QUIT_COMMAND);
      for (int i=0; i<arrayTextFields.length; i++) {
         bindActionListener(arrayTextFields[i], CALCULATE_COMMAND);
         arrayTextFields[i].addKeyListener(tabKeyListener);
      } 
      bindActionListener(itemAbout, SHOW_ABOUT_COMMAND);
      bindWindowListener(this,QUIT_COMMAND);
      
      // register listeners
        
      radioButtonInterest.addItemListener(
         new ItemStateChangedListener("Calculate Interest",textFieldInterest,textFieldMonths)
      );
      radioButtonPayments.addItemListener(
         new ItemStateChangedListener("Calculate Payment",textFieldPayments,textFieldPrinciple)
      );
      radioButtonMonths.addItemListener(
         new ItemStateChangedListener("Calculate Months",textFieldMonths,textFieldPayments)
      );
      radioButtonPrinciple.addItemListener(
         new ItemStateChangedListener("Calculate Principle",textFieldPrinciple, textFieldInterest)
      );
   }
      
  
   // constructors

   public MCalc(String title) {
       this();
       setTitle(title);
   }

   public MCalc(boolean isApplication) {
       this();
       this.isApplication= isApplication;
   }

   public synchronized void show() {
     setLocation(50, 50);
     super.show();
   }
   
   // entry point

   static public void main(String args[]) {
       (new MCalc()).show();
   }

   //{{DECLARE_CONTROLS
   java.awt.FileDialog openFileDialog1;
   java.awt.TextField textFieldPrinciple;
   java.awt.TextField textFieldInterest;
   java.awt.Checkbox radioButtonInterest;
   CheckboxGroup Group1;
   java.awt.Checkbox radioButtonPayments;
   java.awt.Button buttonCalculate;
   java.awt.TextField textFieldMonths;
   java.awt.TextField textFieldPayments;
   java.awt.Checkbox radioButtonPrinciple;
   java.awt.Checkbox radioButtonMonths;
   java.awt.Label labelMessage;
   java.awt.TextField textFieldMessage;
   java.awt.Button buttonQuit;
   //}}

   //{{DECLARE_MENUS
   java.awt.MenuBar mainMenuBar;
   java.awt.Menu menu1;
   java.awt.Menu menu2;
   java.awt.Menu menu3;
   //}}

   //====================
   // User Data
   //====================

   private  java.awt.MenuItem itemExit;
   private  java.awt.MenuItem itemCalculate;
   private  java.awt.MenuItem itemAbout;
   private  TextField[] arrayTextFields= new TextField[4];
   private  TextField   textFieldTarget;
   private  Model       model;
   private  boolean     isApplication= true;

   //====================
   // User Methods
   //====================

   private void initTextArray() {
       arrayTextFields[0]= textFieldPrinciple;
       arrayTextFields[1]= textFieldInterest;
       arrayTextFields[2]= textFieldMonths;
       arrayTextFields[3]= textFieldPayments;
   }
   
   // the following methods should be private, however a bug
   // in JDK1.1 requires package visibility for inner class access
   
   void doExit() {
      setVisible(false);
      dispose();
      if (isApplication) {
         System.exit(0);
      }
   }

   void doCalc() {
       TextField target;
       String message= "";
                       
       target= textFieldTarget;
       target.setText("0");
       message= model.doCalc(arrayTextFields);
       textFieldMessage.setText(message);
       target= getNextTextField(target);
       target.requestFocus();
       target.selectAll();
   }

   TextField getNextTextField(TextField tf){
        TextField temp= null;

        if (tf == arrayTextFields[0]) {temp= arrayTextFields[1];}
        else if (tf == arrayTextFields[1]) {temp= arrayTextFields[2];}
        else if (tf == arrayTextFields[2]) {temp= arrayTextFields[3];}
        else if (tf == arrayTextFields[3]) {temp= arrayTextFields[0];}
        else return tf; // error!
        if (temp.isEditable()) return temp;
        else return (getNextTextField(temp));
   }

   TextField getPreviousTextField(TextField tf){
        TextField temp= null;

        if (tf == arrayTextFields[0]) {temp= arrayTextFields[3];}
        else if (tf == arrayTextFields[1]) {temp= arrayTextFields[0];}
        else if (tf == arrayTextFields[2]) {temp= arrayTextFields[1];}
        else if (tf == arrayTextFields[3]) {temp= arrayTextFields[2];}
        else return tf; // error! 
        if (temp.isEditable()) return temp;
        else return (getPreviousTextField(temp));
   }
     
   void updateControls(String message,TextField current, TextField next) {
      textFieldMessage.setText(message);
      textFieldTarget.setEditable(true);          
      current.setEditable(false);     // buggy  Win95
      current.setText("0");           // workaround
      textFieldTarget= current;
      next.selectAll();
      next.requestFocus(); 
   }
   
   // implement YesNoInterface methods     
   
   public void doYes(Object o, String message) {
      doExit();
   }
   
   public void doNo(Object o, String message) {
      this.toFront();
   } 
}
