import java.io.*;
import java.util.*;
import java.awt.*;

public class ted extends Frame {
    public String filename;
    protected TextArea textarea;
    protected boolean done=false,allowOpen=false;
    protected String MI_OPEN="Open", MI_SAVE="Save", MI_EXIT="Exit";
    protected byte[] data;

//===========================CONSTRUCTOR==================================
    public ted(String filenam){

        super("Scriptis Editor");

        this.filename=filenam;
        if(filename == null){
          this.allowOpen=true;
        }else{
          this.setTitle("Scriptis Editor: "+filename);
          readData(this.filename);
        }//endif

        //set the menu bar
        MenuBar mb = new MenuBar();
        Menu    m  = new Menu("File");
        if(allowOpen)m.add(new MenuItem(MI_OPEN));
        m.add(new MenuItem(MI_SAVE));
        m.add(new MenuItem(MI_EXIT));
        mb.add(m);
        this.setMenuBar(mb);

        this.pack();

    }//end TextEditor constructor
    
//=========================================================================
/** method readData readData(String filename)
Used to load in the data into the instance variable "Byte[] data"
*/
    protected void readData(String filenam){
        File file = new File(filenam);
        readData(file);
    }
//=========================================================================
/** method readData readData(File file)
Used to load in the data into the instance variable "Byte[] data"
hen into the display area: this.textarea

 Query the size of the specified file, create an array of bytes big
 enough, and read it in.  Then create a TextArea to display the text
*/
    protected void readData(File file){
        this.filename=file.toString();
        int size = (int) file.length();
        int bytes_read = 0;
        this.data = new byte[size];

        try{
         FileInputStream in = new FileInputStream(file);
         while(bytes_read < size)
            bytes_read += in.read(this.data, bytes_read, size-bytes_read);
        }catch(FileNotFoundException e){
         allowOpen=true;
        }catch(IOException e){
         System.err.println
                ("Error in TextEditor while reading "+(String)this.filename);
        }

        //load the data into the display area: textarea
        this.textarea = null;
        this.textarea = new TextArea(new String(data, 0), 22, 78);
        textarea.setFont(new Font("Helvetica", Font.PLAIN, 12));
        textarea.setEditable(true);
        this.add("Center", this.textarea);

    }//end readData

//=========================================================================
   public static void main(String args[])
   {
       ted g;
       if (args.length > 0){
        g=new ted(args[0]);
       }else{
        g=new ted(null);
       }
        g.show();
        while(!g.done()){}

       System.exit(0);
   } //end main

//=========================================================================
/** public final method boolean done()
        returns true when the user is finished w/ the Editor.
*/
    public final boolean done(){
        return this.done;
    }//end done()

//=========================================================================
   public boolean handleEvent(Event evt){

       if (evt.id == Event.WINDOW_DESTROY)exitProcedure();
 
       if (evt.target instanceof MenuItem){
           String menuLabel = (String)evt.arg;
           if (menuLabel.equals(MI_OPEN))openFile();

           if (menuLabel.equals(MI_SAVE))saveFile();

           if (menuLabel.equals(MI_EXIT))exitProcedure();

           return true;
       }

       return super.handleEvent(evt);           //whatever else

   } //end handleEvent

//=========================================================================
    protected void openFile(){
        FileDialog fd = new FileDialog(this, "Open a File");
        fd.show();

        if (fd.getFile() != null){
           File file=new File(fd.getDirectory(), fd.getFile()); 
           this.setTitle("Scriptis Editor: "+filename);
           readData(file);
        }//end if(file selected !=null)

    }//end openFile

//=========================================================================

   protected void exitProcedure(){
       SaveDialog sd = new SaveDialog(new Frame());
System.out.println("b4 sd.show");
       sd.show();
System.out.println("past sd.show");
       while(!sd.done){}
System.out.println("past !sd.done");
       if(sd.save.equals(SaveDialog.cancel))return;
       if(sd.save.equals(SaveDialog.no)){}
       if(sd.save.equals(SaveDialog.yes))saveFile();
       sd.dispose();

       this.dispose();
       this.done=true;

   }//end exitProcedure

//=========================================================================

   protected void saveFile(){

      try {
        PrintStream ps=new PrintStream(new FileOutputStream(this.filename));
        ps.print(this.textarea.getText());
        ps.close();
      }catch (IOException e){
        System.err.println("Error while saving "+(String)this.filename);
      }
   }//end saveFile

//=========================================================================
    protected void finalize(){if(this != null)this.dispose();}

//=========================================================================
}//end public class TextEdit
//=========================================================================
//=========================================================================

