/*

	Litte project to demonstrate classes from the fabula.util.* package 
	
		Stefan Bther 

*/ 
import  java.io.*;
import  java.util.*;
import  java.net.*;
import  java.awt.*;

import  fabula.util.DateCalc;
import  fabula.util.Annuity;
import  fabula.util.Rect;
import  fabula.util.Sys;
import  fabula.util.Time;

import  fabula.util.IniFile;

// import  stefc.util.*

class Test {

  private static char TAB	= '\u0009';	
  private static char BELL	= '\u0007';

  public static void main(String[] args) {


	// date calculations 

	Date D = DateCalc.Encode(1997,12,28);
	    
    // Sys.Writeln("Stefan  B\u00f6ther");

	Sys.Writeln("Encode:"+TAB+D); 

	Sys.Writeln("LeapYear:"+TAB+ DateCalc.LeapYear(D));
	Sys.Writeln("DayOfYear:" +TAB+ DateCalc.DayOfYear(D));
	Sys.Writeln("WeekOfYear:"+TAB + DateCalc.WeekOfYear(D));
 
	Sys.Writeln("Year:"+TAB+DateCalc.Year(D)); 
	Sys.Writeln("Month:"+TAB+DateCalc.Month(D)); 
	Sys.Writeln("Day:"+TAB+DateCalc.Day(D)); 
	Sys.Writeln("DayOfWeek:"+TAB+DateCalc.DayOfWeek(D)); 
	Sys.Writeln("DaysInMonth:"+TAB+DateCalc.DaysInMonth(D)); 

	Sys.Writeln("BeginOfYear:"+TAB+DateCalc.BeginOfYear(D)); 
	Sys.Writeln("EndOfYear:"+TAB+DateCalc.EndOfYear(D)); 

	Sys.Writeln("BeginOfMonth:"+TAB+DateCalc.BeginOfMonth(D)); 
	Sys.Writeln("EndOfMonth:"+TAB+DateCalc.EndOfMonth(D)); 

	Sys.Writeln("BeginOfQuarter:"+TAB+DateCalc.BeginOfQuarter(D)); 
	Sys.Writeln("EndOfQuarter:"+TAB+DateCalc.EndOfQuarter(D)); 

	Sys.Writeln("BeginOfWeek:"+TAB+DateCalc.BeginOfWeek(D, DateCalc.MONDAY)); 
	
    Sys.Writeln("Easter:"+TAB+TAB+DateCalc.Easter(DateCalc.Year(D)));

	Sys.Writeln("Quicken:"+TAB+DateCalc.Quicken(D,'+'));


	// Time calculations 

	Date T = Time.Encode(9,35,2);

	Sys.Writeln();
	Sys.Writeln("Time:"+TAB+TAB+T); 
	Sys.Writeln("Hour:"+TAB+TAB+Time.Hour(T)); 
	Sys.Writeln("Minute:"+TAB+TAB+Time.Min(T)); 
	Sys.Writeln("Second:"+TAB+TAB+Time.Sec(T)); 
	Sys.Writeln("TimeZoneOfs:"+TAB+Time.ZoneOffset()); 
	Sys.Writeln("AsInteger:"+TAB+Time.ToInt(T)); 

	int x = 12;

	Object[] y = { new Integer(x), "Hello World" };

	System.out.println( y[0] ); 
	System.out.println( y[1] );

	Sys.Readln();

	// Annuitten Berechnung 

	Sys.Writeln();

	
    double aEFZ = Annuity.Uniform(0.53,0,120);
	Sys.Writeln("Unform :"+TAB+aEFZ);
	aEFZ = Annuity.Calc(0.53,0,120,aEFZ);
	Sys.Writeln("Annuity:"+TAB+aEFZ);


	// Rectangle functions 

	Sys.Writeln();

	Rectangle R = Rect.Bounds(10,10,30,20);

	Sys.Writeln("Rectangle:"+TAB+R); 
	Sys.Writeln("CentralPoint:"+TAB+Rect.CentralPoint(R) ); 


	// System functions 

	Sys.Writeln(); 

	Sys.Writeln("Start at:"+TAB+new Date());
	Sys.Delay(1000); 
	Sys.Beep(); 
	Sys.Writeln("End at:"+TAB+TAB+new Date());
	Sys.Writeln("Java Version:"+TAB+Sys.JavaVersion());
	Sys.Writeln("Os Name:"+TAB+Sys.OsName());
	Sys.Writeln("Os Version:"+TAB+Sys.OsVersion());

	System.getProperties().list(System.out);
	Sys.Readln();

	IniFile aIni;
	try {
		aIni = new IniFile( "c:/test.ini" ); 
		try {
			Sys.Writeln(aIni.ReadString("What","Three","nothing"));
			aIni.WriteString("Test","Item", "Value"); 
		} 
		finally {
			aIni.Close();
		}
	}
	catch (IOException e) {
		System.err.println("Error:"+e);
	}
	Sys.Readln();
  }


}