// From the example from the book _Java in a Nutshell_ by David Flanagan.

import java.awt.*;

public class YesNoDialog extends Dialog {

    protected Button yes = null, no = null, cancel = null;
    protected MultiLineLabel label;
    protected boolean done=false;
    public static String yes_label,no_label,cancel_label;
    public String decision;
    
    public YesNoDialog(Frame parent, String title, String message,
               String yes_label, String no_label, String cancel_label)
    {
        // Create the window.
        super(parent, title, true);

        YesNoDialog.yes_label=yes_label;
        YesNoDialog.no_label=no_label;
        YesNoDialog.cancel_label=cancel_label;

        // Specify a LayoutManager for it
        this.setLayout(new BorderLayout(15, 15));
        
        // Put the message label in the middle of the window.
        label = new MultiLineLabel(message, 20, 20);
        this.add("North", label);
        
        // Create a panel of buttons, center the row of buttons in
        // the panel, and put the pane at the bottom of the window.
        Panel panel = new Panel();
        panel.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
        if (yes_label != null) panel.add(yes = new Button(yes_label));
        if (no_label != null)  panel.add(no = new Button(no_label));
        if (cancel_label != null) panel.add(cancel = new Button(cancel_label));
        this.add("South", panel);

        this.pack();          //Is this buggy?

    }
    
    // Handle button events by calling the answer() method.
    // Pass the appropriate constant value, depending on the button.
    public boolean action(Event e, Object arg)
    {
        if (e.target instanceof Button) {
            this.hide();
            if (e.target == yes) {yes(); this.done=true;}
            else if (e.target == no) {no(); this.done=true;}
            else {cancel(); this.done=true;}
            return true;
        }
        else return false;
    }
    
    protected void yes() {decision=yes_label;}
    protected void no() {decision=no_label;}
    protected void cancel() {decision=cancel_label;}
//=========================================================================
/**  YesNoDialog.done()
method returns the finished status of the dialog box
*/
        public final boolean done(){
            return this.done;
        }

//=========================================================================
//    protected void finalize(){
//        this.dispose();
//    }//end finalizer
//=========================================================================

}//end public class YesNoDialog
