/*
 * @(#)Time.java	
 *
 * Copyright (c) 1997 Fabula Software GmbH. All Rights Reserved.
 *
 * <a href=http://www.fabula.com>Fabula Software GmbH</a>
 * <a href=mailto:info@fabula.com>eMail</a>
 */

package fabula.util;

import java.util.Date;

/**
 * The class <code>Time</code> defines several methods for accessing 
 * time methods from java.
 * <p>
 *
 * @author  <a href="mailto:stefc@fabula.com">Stefan Bther</a>
 * @company <a href="http://www.fabula.com">Fabula Software</a>
 * @version 1.00, 31 Mar 1997
 */

public class Time {

	/**
	 * Don't let anyone instantiate this class.
	 */
	private Time() {}

	/**
	 * Encodes the time 
	 */
	public static Date Encode(int aHour, int aMin, int aSec) {
		return new Date(Date.UTC(97,3,31,aHour,aMin,aSec)); 
	}

	/**
	 * Returns the current time 
	 */
	public static Date Now () {
		Date D = new Date();
		return Encode(D.getHours(),D.getMinutes(),D.getSeconds());
	}


	/**
	 * Returns the hour of the time
	 */
	public static int Hour(Date D) {
		return D.getHours(); 
	}

	/**
	 * Returns the minute of the time 
	 */
	public static int Min(Date D) {
		return D.getMinutes();
	}

	/**
	 * Returns the seconds of the time 
	 */
	public static int Sec(Date D) {
		return D.getSeconds();
	}

	/**
	 * Returns the time as integer contains the time in seconds 
	 */
	public static long ToInt(Date D) {
		return D.getHours() * 60 * 60 + 
			   D.getMinutes() * 60 +
			   D.getSeconds();
	}

	/**
	 * Returns the Timezone offset from Greenwhichmeantime GMT 
	 * to the local timezone
	 */
	public static int ZoneOffset () {
		return new Date().getTimezoneOffset();
	}
	
}




